searchNodes=[{"type":"module","title":"nova","doc":"Interface module for nova","ref":"nova.html"},{"type":"function","title":"nova.get_apps/0","doc":"Returns a proplist with all nova applications and their prefix. This function is useful when calulating dynamic routes.","ref":"nova.html#get_apps/0"},{"type":"function","title":"nova.get_env/2","doc":"Works as the regular application:get_env/3 but instead of giving a specific application we target the application that started nova.","ref":"nova.html#get_env/2"},{"type":"function","title":"nova.get_environment/0","doc":"Returns which environment nova is started in. This fetches the environment-variable in sys.config for Nova and returns the value found. Defaults to: dev","ref":"nova.html#get_environment/0"},{"type":"function","title":"nova.get_main_app/0","doc":"Returns the name of the main bw-application (The one that started everything)","ref":"nova.html#get_main_app/0"},{"type":"function","title":"nova.set_env/2","doc":"Sets an environment variable for the main application.","ref":"nova.html#set_env/2"},{"type":"type","title":"nova.state/0","doc":"","ref":"nova.html#t:state/0"},{"type":"module","title":"nova_app","doc":"Nova application behaviour callback (Not used)","ref":"nova_app.html"},{"type":"function","title":"nova_app.start/2","doc":"","ref":"nova_app.html#start/2"},{"type":"function","title":"nova_app.stop/1","doc":"","ref":"nova_app.html#stop/1"},{"type":"module","title":"nova_basic_handler","doc":"","ref":"nova_basic_handler.html"},{"type":"function","title":"nova_basic_handler.handle_json/3","doc":"Handler for JSON. It takes two different return objects: {json, JSON :: map()} returns the JSON encoded to the user. If the operation was a POST the HTTP-status code will be 201, otherwise 200. {json, StatusCode :: integer(), Headers :: map(), JSON :: map()} Same operation as the above except you can set custom status code and custom headers.","ref":"nova_basic_handler.html#handle_json/3"},{"type":"function","title":"nova_basic_handler.handle_ok/3","doc":"Handler for regular views. This will render a template with given variables. If not another view is specified in options a view that corresponds to the controller will be rendered. The first element of the returned tuple could be either ok or view - they are identical in their functionality. -module(my_first_controller). -compile(export_all). my_function(_Req) -&gt; {ok, []}. The example above will then render the view named 'app_main.dtl' Options can be specified as follows: - view - Specifies if another view should be rendered instead of default one - headers - Custom headers","ref":"nova_basic_handler.html#handle_ok/3"},{"type":"function","title":"nova_basic_handler.handle_redirect/3","doc":"Handles redirects. This will return a 302-status code with a location given by the user. Something like {redirect, &quot;/login&quot;} will send a 302 with location set to &quot;/login&quot;","ref":"nova_basic_handler.html#handle_redirect/3"},{"type":"function","title":"nova_basic_handler.handle_sendfile/3","doc":"Handles sendfile.","ref":"nova_basic_handler.html#handle_sendfile/3"},{"type":"function","title":"nova_basic_handler.handle_status/3","doc":"Handler for returning http status codes. There's three different ways one can return status code. The most basic case is {status, Status} where Status is the code that should be returned. If there's a need for additional headers to be sent along with the http code one can specify a third argument that is a map with header-fields. One can also send in a body as a fourth argument in the tuple. It can either be a binary or a map. If it's a map it will be considered a JSON-structure and encoded.","ref":"nova_basic_handler.html#handle_status/3"},{"type":"function","title":"nova_basic_handler.handle_view/3","doc":"Handler for regular views and uses the ok-handler. For more info see handle_ok/3.","ref":"nova_basic_handler.html#handle_view/3"},{"type":"function","title":"nova_basic_handler.handle_websocket/3","doc":"Handles upgrading to websocket","ref":"nova_basic_handler.html#handle_websocket/3"},{"type":"function","title":"nova_basic_handler.handle_ws/2","doc":"Handles basic websocket operations. This is a special handler in regards to arguments. Handlers for websocket only takes two arguments; What the controller returned and the state. And the handler should return what cowboy expects. Example of a valid return value is {reply, Frame, State}","ref":"nova_basic_handler.html#handle_ws/2"},{"type":"type","title":"nova_basic_handler.erlydtl_vars/0","doc":"","ref":"nova_basic_handler.html#t:erlydtl_vars/0"},{"type":"type","title":"nova_basic_handler.mod_fun/0","doc":"","ref":"nova_basic_handler.html#t:mod_fun/0"},{"type":"module","title":"nova_correlation_plugin","doc":"Plugin Configuration To not break backwards compatibility in a minor release, some behavior is behind configuration items. Request Correlation Header Name Set request_correlation_header in the plugin config to read the correlation ID from the request headers. Notice: Cowboy request headers are always in lowercase. Default Correlation ID Generation If the header name is not defined or the request lacks a correlation ID header, then the plugin generates a v4 UUID automatically. Logger Metadata Key Override Use logger_metadata_key to customize the correlation ID key in OTP logger process metadata. By default it is set to &lt;&lt;&quot;correlation-id&quot;&gt;&gt; . Correlation ID in Request Object The plugin defines a field called correlation_id in the request object for controller use if it makes further requests that it want to pass on the correlation id to. Example configuration {plugins, [ {pre_request, nova_correlation_plugin, \#{ request_correlation_header =&gt; &lt;&lt;&quot;x-correlation-id&quot;&gt;&gt;, logger_metadata_key =&gt; correlation_id }} ]}","ref":"nova_correlation_plugin.html"},{"type":"function","title":"nova_correlation_plugin.plugin_info/0","doc":"","ref":"nova_correlation_plugin.html#plugin_info/0"},{"type":"function","title":"nova_correlation_plugin.post_request/2","doc":"","ref":"nova_correlation_plugin.html#post_request/2"},{"type":"function","title":"nova_correlation_plugin.pre_request/2","doc":"Pre-request callback to either pick up correlation id from request headers or generate a new uuid correlation id.","ref":"nova_correlation_plugin.html#pre_request/2"},{"type":"module","title":"nova_cors_plugin","doc":"","ref":"nova_cors_plugin.html"},{"type":"function","title":"nova_cors_plugin.plugin_info/0","doc":"nova_plugin callback. Returns information about the plugin.","ref":"nova_cors_plugin.html#plugin_info/0"},{"type":"function","title":"nova_cors_plugin.post_request/2","doc":"Post-request callback","ref":"nova_cors_plugin.html#post_request/2"},{"type":"function","title":"nova_cors_plugin.pre_request/2","doc":"Pre-request callback","ref":"nova_cors_plugin.html#pre_request/2"},{"type":"module","title":"nova_erlydtl_inventory","doc":"","ref":"nova_erlydtl_inventory.html"},{"type":"function","title":"nova_erlydtl_inventory.inventory/1","doc":"","ref":"nova_erlydtl_inventory.html#inventory/1"},{"type":"function","title":"nova_erlydtl_inventory.url/2","doc":"","ref":"nova_erlydtl_inventory.html#url/2"},{"type":"function","title":"nova_erlydtl_inventory.version/0","doc":"","ref":"nova_erlydtl_inventory.html#version/0"},{"type":"module","title":"nova_error_controller","doc":"","ref":"nova_error_controller.html"},{"type":"function","title":"nova_error_controller.not_found/1","doc":"","ref":"nova_error_controller.html#not_found/1"},{"type":"function","title":"nova_error_controller.server_error/1","doc":"","ref":"nova_error_controller.html#server_error/1"},{"type":"function","title":"nova_error_controller.status_code/1","doc":"","ref":"nova_error_controller.html#status_code/1"},{"type":"behaviour","title":"nova_handler","doc":"","ref":"nova_handler.html"},{"type":"function","title":"nova_handler.execute/2","doc":"","ref":"nova_handler.html#execute/2"},{"type":"callback","title":"nova_handler.init/2","doc":"","ref":"nova_handler.html#c:init/2"},{"type":"function","title":"nova_handler.terminate/3","doc":"","ref":"nova_handler.html#terminate/3"},{"type":"callback","title":"nova_handler.terminate/3","doc":"","ref":"nova_handler.html#c:terminate/3"},{"type":"module","title":"nova_handlers","doc":"This module is responsible for all the different return types a controller have. Nova is constructed in such way that it's really easy to extend it by using handlers . A handler is basically a module consisting of a function of arity 4. We will show an example of this. If you implement the following module: -module(my_handler). -export([init/0, handle_console]). init() -&gt; nova_handlers:register_handler(console, {my_handler, handle_console}). handle_console({console, Format, Args}, {Module, Function}, State) -&gt; io:format(&quot;~n=====================~n&quot;, []). io:format(&quot;~p:~p was called.~n&quot;, []), io:format(&quot;State: ~p~n&quot;, [State]), io:format(Format, Args), io:format(&quot;~n=====================~n&quot;, []), {ok, 200, \#{}, EmptyBinary}. The init/0 should be invoked from your applications supervisor and will register the module my_handler as handler of the return type {console, Format, Args}. This means that you can return this tuple in a controller which invokes my_handler:handle_console/4. A handler can return two different types {ok, StatusCode, Headers, Body} - This will return a proper reply to the requester. {error, Reason} - This will render a 500 page to the user.","ref":"nova_handlers.html"},{"type":"function","title":"nova_handlers.code_change/3","doc":"Convert process state when code is changed","ref":"nova_handlers.html#code_change/3"},{"type":"function","title":"nova_handlers.format_status/2","doc":"This function is called for changing the form and appearance of gen_server status when it is returned from sys:get_status/1,2 or when it appears in termination error logs.","ref":"nova_handlers.html#format_status/2"},{"type":"function","title":"nova_handlers.get_handler/1","doc":"Fetches the handler identified with 'Handle' and returns the callback function for it.","ref":"nova_handlers.html#get_handler/1"},{"type":"function","title":"nova_handlers.handle_call/3","doc":"Handling call messages","ref":"nova_handlers.html#handle_call/3"},{"type":"function","title":"nova_handlers.handle_cast/2","doc":"Handling cast messages","ref":"nova_handlers.html#handle_cast/2"},{"type":"function","title":"nova_handlers.handle_info/2","doc":"Handling all non call/cast messages","ref":"nova_handlers.html#handle_info/2"},{"type":"function","title":"nova_handlers.init/1","doc":"Initializes the server","ref":"nova_handlers.html#init/1"},{"type":"function","title":"nova_handlers.register_handler/2","doc":"Registers a new handler. This can then be used in a nova controller by returning a tuple where the first element is the name of the handler.","ref":"nova_handlers.html#register_handler/2"},{"type":"function","title":"nova_handlers.start_link/0","doc":"","ref":"nova_handlers.html#start_link/0"},{"type":"function","title":"nova_handlers.terminate/2","doc":"This function is called by a gen_server when it is about to terminate. It should be the opposite of Module:init/1 and do any necessary cleaning up. When it returns, the gen_server terminates with Reason. The return value is ignored.","ref":"nova_handlers.html#terminate/2"},{"type":"function","title":"nova_handlers.unregister_handler/1","doc":"Unregisters a handler and makes it unavailable for all controllers.","ref":"nova_handlers.html#unregister_handler/1"},{"type":"type","title":"nova_handlers.handler_callback/0","doc":"","ref":"nova_handlers.html#t:handler_callback/0"},{"type":"type","title":"nova_handlers.handler_return/0","doc":"","ref":"nova_handlers.html#t:handler_return/0"},{"type":"behaviour","title":"nova_plugin","doc":"Plugins can be run at two different times; either in the beginning or at the end of a request. They can modify both the actual request or the nova-state. A plugin is implemented with the nova_plugin behaviour and needs to implement three different functions: pre_request/2, post_request/2 and plugin_info/0. A plugin can return either {ok, NewState}, {break, NewState}, {stop, NewState}, {error, Reason}. {ok, NewState} will continue the normal execution with the NewState. {break, NewState} breaks the execution of the current plugin-chain. This means that if a pre_request-plugin returns the break-statement the rest of the plugins in that chain will be skipped. {stop, NewState} stops the execution. The plugin is responsible in this case for returning a proper response to the client. {error, Reason} will stop the execution and call the nova_error plugin, resulting in a 500 response back to the user. If debug mode is enabled the reason will be returned in the 500-response.","ref":"nova_plugin.html"},{"type":"callback","title":"nova_plugin.plugin_info/0","doc":"","ref":"nova_plugin.html#c:plugin_info/0"},{"type":"callback","title":"nova_plugin.post_request/2","doc":"","ref":"nova_plugin.html#c:post_request/2"},{"type":"callback","title":"nova_plugin.pre_request/2","doc":"","ref":"nova_plugin.html#c:pre_request/2"},{"type":"type","title":"nova_plugin.request_type/0","doc":"","ref":"nova_plugin.html#t:request_type/0"},{"type":"module","title":"nova_plugin_handler","doc":"","ref":"nova_plugin_handler.html"},{"type":"function","title":"nova_plugin_handler.execute/2","doc":"","ref":"nova_plugin_handler.html#execute/2"},{"type":"module","title":"nova_pubsub","doc":"Pubsub system for Nova. It uses the pg/pg2 module. Pubsub subsystem is started with Nova and does not need any additional configuration. It uses the pg/pg2 module depending on the version of OTP. It provides a simple way of distributing messages to a large set of receivers and exposes a simple set of functions for doing that. A simple example of how to use pubsub in a ping/pong inspired game engine: -module(test_module). -export([player1/0, player2/0, start_game/0]). player1() -&gt; spawn(fun() -&gt; nova_pubsub:join(game_of_pong), game_loop(1, &quot;pong&quot;, &quot;ping&quot;). player2() -&gt; spawn(fun() -&gt; nova_pubsub:join(game_of_pong), game_loop(2, &quot;ping&quot;, &quot;pong&quot;). game_loop(Player, ExpectedMessage, Smash) -&gt; receive ExpectedMessage -&gt; io:format(&quot;Player ~d received ~s and returning ~s~n&quot;, [Player, ExpectedMessage, Smash]), nova_pubsub:broadcast(game_of_pong, &quot;match1&quot;, Smash), game_loop(Player, ExpectedMessage, Smash); _ -&gt; game_loop(Player, ExpectedMessage, Smash) end.","ref":"nova_pubsub.html"},{"type":"function","title":"nova_pubsub.broadcast/3","doc":"Broadcasts a message to all members of a channel. Topic is specified to differentiate messages within the same channel.","ref":"nova_pubsub.html#broadcast/3"},{"type":"function","title":"nova_pubsub.get_local_members/1","doc":"Works the same way as get_members/1 but returns only members on the same node.","ref":"nova_pubsub.html#get_local_members/1"},{"type":"function","title":"nova_pubsub.get_members/1","doc":"Returns all members for a given channel","ref":"nova_pubsub.html#get_members/1"},{"type":"function","title":"nova_pubsub.join/1","doc":"Joining a channel with the calling process. Always returns ok","ref":"nova_pubsub.html#join/1"},{"type":"function","title":"nova_pubsub.join/2","doc":"Same as join/1 but with a specified process.","ref":"nova_pubsub.html#join/2"},{"type":"function","title":"nova_pubsub.leave/1","doc":"Leaves a channnel. Will return ok on success and not_joined if the calling process were not part of the channel.","ref":"nova_pubsub.html#leave/1"},{"type":"function","title":"nova_pubsub.leave/2","doc":"Same as leave/1 but with a specified process.","ref":"nova_pubsub.html#leave/2"},{"type":"function","title":"nova_pubsub.local_broadcast/3","doc":"Works in the same way as broadcast/3 but only for members in the same node.","ref":"nova_pubsub.html#local_broadcast/3"},{"type":"function","title":"nova_pubsub.start/0","doc":"","ref":"nova_pubsub.html#start/0"},{"type":"module","title":"nova_request_plugin","doc":"","ref":"nova_request_plugin.html"},{"type":"function","title":"nova_request_plugin.plugin_info/0","doc":"nova_plugin callback. Returns information about the plugin.","ref":"nova_request_plugin.html#plugin_info/0"},{"type":"function","title":"nova_request_plugin.post_request/2","doc":"Post-request callback","ref":"nova_request_plugin.html#post_request/2"},{"type":"function","title":"nova_request_plugin.pre_request/2","doc":"Pre-request callback","ref":"nova_request_plugin.html#pre_request/2"},{"type":"behaviour","title":"nova_router","doc":"","ref":"nova_router.html"},{"type":"function","title":"nova_router.compile/1","doc":"","ref":"nova_router.html#compile/1"},{"type":"function","title":"nova_router.compiled_apps/0","doc":"","ref":"nova_router.html#compiled_apps/0"},{"type":"function","title":"nova_router.execute/2","doc":"","ref":"nova_router.html#execute/2"},{"type":"function","title":"nova_router.lookup_url/1","doc":"","ref":"nova_router.html#lookup_url/1"},{"type":"function","title":"nova_router.lookup_url/2","doc":"","ref":"nova_router.html#lookup_url/2"},{"type":"function","title":"nova_router.lookup_url/3","doc":"","ref":"nova_router.html#lookup_url/3"},{"type":"function","title":"nova_router.render_status_page/2","doc":"","ref":"nova_router.html#render_status_page/2"},{"type":"function","title":"nova_router.render_status_page/3","doc":"","ref":"nova_router.html#render_status_page/3"},{"type":"function","title":"nova_router.render_status_page/5","doc":"","ref":"nova_router.html#render_status_page/5"},{"type":"function","title":"nova_router.routes/1","doc":"","ref":"nova_router.html#routes/1"},{"type":"callback","title":"nova_router.routes/1","doc":"","ref":"nova_router.html#c:routes/1"},{"type":"type","title":"nova_router.bindings/0","doc":"","ref":"nova_router.html#t:bindings/0"},{"type":"type","title":"nova_router.host_tree/0","doc":"","ref":"nova_router.html#t:host_tree/0"},{"type":"type","title":"nova_router.options/0","doc":"","ref":"nova_router.html#t:options/0"},{"type":"type","title":"nova_router.routing_tree/0","doc":"","ref":"nova_router.html#t:routing_tree/0"},{"type":"module","title":"nova_security_handler","doc":"","ref":"nova_security_handler.html"},{"type":"function","title":"nova_security_handler.execute/2","doc":"","ref":"nova_security_handler.html#execute/2"},{"type":"behaviour","title":"nova_session","doc":"All kind of operations on sessions is handled by the nova_session-module. The module also presents a behaviour that can be used to create customized backends for the session-data.","ref":"nova_session.html"},{"type":"function","title":"nova_session.delete/1","doc":"","ref":"nova_session.html#delete/1"},{"type":"function","title":"nova_session.delete/2","doc":"","ref":"nova_session.html#delete/2"},{"type":"callback","title":"nova_session.delete_value/1","doc":"","ref":"nova_session.html#c:delete_value/1"},{"type":"callback","title":"nova_session.delete_value/2","doc":"","ref":"nova_session.html#c:delete_value/2"},{"type":"function","title":"nova_session.generate_session_id/0","doc":"","ref":"nova_session.html#generate_session_id/0"},{"type":"function","title":"nova_session.get/2","doc":"","ref":"nova_session.html#get/2"},{"type":"callback","title":"nova_session.get_value/2","doc":"","ref":"nova_session.html#c:get_value/2"},{"type":"function","title":"nova_session.set/3","doc":"","ref":"nova_session.html#set/3"},{"type":"callback","title":"nova_session.set_value/3","doc":"","ref":"nova_session.html#c:set_value/3"},{"type":"module","title":"nova_session_ets","doc":"","ref":"nova_session_ets.html"},{"type":"function","title":"nova_session_ets.code_change/3","doc":"Convert process state when code is changed","ref":"nova_session_ets.html#code_change/3"},{"type":"function","title":"nova_session_ets.delete_value/1","doc":"","ref":"nova_session_ets.html#delete_value/1"},{"type":"function","title":"nova_session_ets.delete_value/2","doc":"","ref":"nova_session_ets.html#delete_value/2"},{"type":"function","title":"nova_session_ets.format_status/2","doc":"This function is called for changing the form and appearance of gen_server status when it is returned from sys:get_status/1,2 or when it appears in termination error logs.","ref":"nova_session_ets.html#format_status/2"},{"type":"function","title":"nova_session_ets.get_value/2","doc":"","ref":"nova_session_ets.html#get_value/2"},{"type":"function","title":"nova_session_ets.handle_call/3","doc":"Handling call messages","ref":"nova_session_ets.html#handle_call/3"},{"type":"function","title":"nova_session_ets.handle_cast/2","doc":"Handling cast messages","ref":"nova_session_ets.html#handle_cast/2"},{"type":"function","title":"nova_session_ets.handle_info/2","doc":"Handling all non call/cast messages","ref":"nova_session_ets.html#handle_info/2"},{"type":"function","title":"nova_session_ets.init/1","doc":"Initializes the server","ref":"nova_session_ets.html#init/1"},{"type":"function","title":"nova_session_ets.set_value/3","doc":"","ref":"nova_session_ets.html#set_value/3"},{"type":"function","title":"nova_session_ets.start_link/0","doc":"Starts the server","ref":"nova_session_ets.html#start_link/0"},{"type":"function","title":"nova_session_ets.terminate/2","doc":"This function is called by a gen_server when it is about to terminate. It should be the opposite of Module:init/1 and do any necessary cleaning up. When it returns, the gen_server terminates with Reason. The return value is ignored.","ref":"nova_session_ets.html#terminate/2"},{"type":"module","title":"nova_stream_h","doc":"","ref":"nova_stream_h.html"},{"type":"function","title":"nova_stream_h.data/4","doc":"","ref":"nova_stream_h.html#data/4"},{"type":"function","title":"nova_stream_h.early_error/5","doc":"","ref":"nova_stream_h.html#early_error/5"},{"type":"function","title":"nova_stream_h.info/3","doc":"","ref":"nova_stream_h.html#info/3"},{"type":"function","title":"nova_stream_h.init/3","doc":"","ref":"nova_stream_h.html#init/3"},{"type":"function","title":"nova_stream_h.terminate/3","doc":"","ref":"nova_stream_h.html#terminate/3"},{"type":"type","title":"nova_stream_h.state/0","doc":"","ref":"nova_stream_h.html#t:state/0"},{"type":"module","title":"nova_sup","doc":"Nova supervisor","ref":"nova_sup.html"},{"type":"function","title":"nova_sup.init/1","doc":"Whenever a supervisor is started using supervisor:start_link/[2,3], this function is called by the new process to find out about restart strategy, maximum restart intensity, and child specifications.","ref":"nova_sup.html#init/1"},{"type":"function","title":"nova_sup.start_link/0","doc":"Starts the supervisor","ref":"nova_sup.html#start_link/0"},{"type":"module","title":"nova_watcher","doc":"","ref":"nova_watcher.html"},{"type":"function","title":"nova_watcher.async_cast/1","doc":"","ref":"nova_watcher.html#async_cast/1"},{"type":"function","title":"nova_watcher.async_cast/2","doc":"","ref":"nova_watcher.html#async_cast/2"},{"type":"function","title":"nova_watcher.async_cast/3","doc":"","ref":"nova_watcher.html#async_cast/3"},{"type":"function","title":"nova_watcher.async_cast/4","doc":"","ref":"nova_watcher.html#async_cast/4"},{"type":"function","title":"nova_watcher.code_change/3","doc":"Convert process state when code is changed","ref":"nova_watcher.html#code_change/3"},{"type":"function","title":"nova_watcher.format_status/2","doc":"This function is called for changing the form and appearance of gen_server status when it is returned from sys:get_status/1,2 or when it appears in termination error logs.","ref":"nova_watcher.html#format_status/2"},{"type":"function","title":"nova_watcher.handle_call/3","doc":"Handling call messages","ref":"nova_watcher.html#handle_call/3"},{"type":"function","title":"nova_watcher.handle_cast/2","doc":"Handling cast messages","ref":"nova_watcher.html#handle_cast/2"},{"type":"function","title":"nova_watcher.handle_info/2","doc":"Handling all non call/cast messages","ref":"nova_watcher.html#handle_info/2"},{"type":"function","title":"nova_watcher.init/1","doc":"Initializes the server","ref":"nova_watcher.html#init/1"},{"type":"function","title":"nova_watcher.start_link/0","doc":"Starts the server","ref":"nova_watcher.html#start_link/0"},{"type":"function","title":"nova_watcher.stop/0","doc":"","ref":"nova_watcher.html#stop/0"},{"type":"function","title":"nova_watcher.terminate/2","doc":"This function is called by a gen_server when it is about to terminate. It should be the opposite of Module:init/1 and do any necessary cleaning up. When it returns, the gen_server terminates with Reason. The return value is ignored.","ref":"nova_watcher.html#terminate/2"},{"type":"behaviour","title":"nova_websocket","doc":"","ref":"nova_websocket.html"},{"type":"callback","title":"nova_websocket.init/1","doc":"","ref":"nova_websocket.html#c:init/1"},{"type":"callback","title":"nova_websocket.terminate/3","doc":"","ref":"nova_websocket.html#c:terminate/3"},{"type":"callback","title":"nova_websocket.websocket_handle/2","doc":"","ref":"nova_websocket.html#c:websocket_handle/2"},{"type":"callback","title":"nova_websocket.websocket_info/2","doc":"","ref":"nova_websocket.html#c:websocket_info/2"},{"type":"callback","title":"nova_websocket.websocket_init/1","doc":"","ref":"nova_websocket.html#c:websocket_init/1"},{"type":"type","title":"nova_websocket.call_result/0","doc":"","ref":"nova_websocket.html#t:call_result/0"},{"type":"type","title":"nova_websocket.in_frame/0","doc":"","ref":"nova_websocket.html#t:in_frame/0"},{"type":"module","title":"nova_ws_handler","doc":"Callback controller for handling websockets","ref":"nova_ws_handler.html"},{"type":"function","title":"nova_ws_handler.init/2","doc":"","ref":"nova_ws_handler.html#init/2"},{"type":"function","title":"nova_ws_handler.terminate/3","doc":"","ref":"nova_ws_handler.html#terminate/3"},{"type":"function","title":"nova_ws_handler.websocket_handle/2","doc":"","ref":"nova_ws_handler.html#websocket_handle/2"},{"type":"function","title":"nova_ws_handler.websocket_info/2","doc":"","ref":"nova_ws_handler.html#websocket_info/2"},{"type":"function","title":"nova_ws_handler.websocket_init/1","doc":"","ref":"nova_ws_handler.html#websocket_init/1"},{"type":"type","title":"nova_ws_handler.nova_ws_state/0","doc":"","ref":"nova_ws_handler.html#t:nova_ws_state/0"},{"type":"extras","title":"Quick start","doc":"","ref":"quick-start.html"},{"type":"extras","title":"Quick start - Start your first project","doc":"Nova provides a plugin to make working with the framework a lot easier. One can install it by either using an automated installation or include it manually in the global rebar.config file. Note If you require help installing Erlang and/or rebar3 please check https://adoptingerlang.org/docs/development/setup/ Automated installation Via Curl sh -c &quot;$(curl -fsSL https://raw.githubusercontent.com/novaframework/rebar3_nova/master/install.sh)&quot; Via wget sh -c &quot;$(wget -O- https://raw.githubusercontent.com/novaframework/rebar3_nova/master/install.sh)&quot; Manual installation Open your rebar.config file that should reside in ~/.config/rebar3/rebar.config* . If the file does not exist you can just create it. Locate the plugins section of the file and include the nova plugin. The result should look something like the following: { plugins , [ { rebar3_nova , { git , &quot;https://github.com/novaframework/rebar3_nova.git&quot; , { branch , &quot;master&quot; } } } ] } . Creating the skeleton After the installation of the Nova-plugin is done use rebar3 to generate a new project. rebar3 new nova my_first_nova $ rebar3 new nova my_first_app ===&gt; Writing my_first_nova/config/dev_sys.config.src ===&gt; Writing my_first_nova/config/prod_sys.config.src ===&gt; Writing my_first_nova/src/my_first_nova.app.src ===&gt; Writing my_first_nova/src/my_first_nova_app.erl ===&gt; Writing my_first_nova/src/my_first_nova_sup.erl ===&gt; Writing my_first_nova/src/my_first_nova_router.erl ===&gt; Writing my_first_nova/src/controllers/my_first_nova_main_controller.erl ===&gt; Writing my_first_nova/rebar.config ===&gt; Writing my_first_nova/config/vm.args.src ===&gt; Writing my_first_nova/src/views/my_first_nova_main.dtl Now the skeleton have been created and you should be able to start it. Go into the newly created directory and run the serve command. Note For the auto-compile/reload to work you need inotify to be installed. $ cd my_first_app $ rebar3 nova serve ===&gt; Verifying dependencies... ===&gt; Compiling my_first_app Erlang/OTP 20 [erts-9.3] [source] [64-bit] [smp:8:8] [ds:8:8:10] [async-threads:0] [hipe] [kernel-poll:false] ... a lot of progress-reports ... ===&gt; Booted my_first_app ... If you take a look at http://localhost:8080 you should be greeted by a Nova-page.","ref":"quick-start.html#start-your-first-project"},{"type":"extras","title":"Routing","doc":"Each nova application have their own routes file. This file contains information about all the routes existing for this application.","ref":"routing.html"},{"type":"extras","title":"Routing - Basic components","doc":"A simple route file could look something like this: - module ( my_app_router ) . - export ( [ routes / 1 ] ) . routes ( _ Environment ) -&gt; [ \#{ prefix =&gt; &quot;/admin&quot; , security =&gt; false , routes =&gt; [ { &quot;/&quot; , { my_controller , main } , \#{ methods =&gt; [ get ] } } ] } ] . This will create a path for /admin which, when a user enters will call my_controller:main/1 . The _Environment variable that is consumed by the routes function will have the value that nova:get_environment/0 returns. The environment variable is an important thing cause it enables the devlopers to define different routes for different environments. To change the running environment edit the sys.config file to include an {environment, Env} tuple under the nova application where Env can be any erlang-term. The routing object The routing object consists of three or four fields. HTTP(S) Routing { Route :: list ( ) , { Controller :: atom ( ) , Function :: atom ( ) } , Options :: map ( ) } As you saw in the initial example in the Basic components section, we defined a route for the root path / . Websocket routing { Route :: list ( ) , Controller :: atom ( ) , Options :: map ( ) } Important One needs to define protocol =&gt; ws in the options-map in order to enable websocket communications.","ref":"routing.html#basic-components"},{"type":"extras","title":"Routing - How to create routes","doc":"A route consists of four different components: Path - This is the actual path to the endpoint. Eg &quot;/admin&quot; Method - What method you want to support for this endpoint (get, post, update, delete). If you want to support all methods you can use the '_' -atom. Controller - What erlang module should be called on when the path gets called. Function - Which function in the Controller will be called when path gets called.","ref":"routing.html#how-to-create-routes"},{"type":"extras","title":"Routing - Using prefix","doc":"You can group paths where you prefix them with a path. This is especially useful when having several different nova applications running. A very common example would be if you had an administration interface. Then the prefix would be &quot;/admin&quot; . Another example is versioned APIs. Prefix is defined at top level of a route-entry which can be seen in the Basic components section of this chapter.","ref":"routing.html#using-prefix"},{"type":"extras","title":"Routing - Secure routing","doc":"You can secure routes by providing a module and function to the security directive in the route entry. Here's a simple example of this: \#{ prefix =&gt; &quot;/admin&quot; , type =&gt; html , security =&gt; { security_controller , do_security } , routes =&gt; [ { &quot;/&quot; , { my_controller , main } , \#{ methods =&gt; [ get ] } } ] } This will cause nova to call security_controller:do_security/1 before calling the actual controller for all routes defined in the above route entry. The security function should return a boolean (If the user can proceed or not). An example of a security function: do_security ( Req ) -&gt; maps : get ( host , Req ) == &quot;my_domain.com&quot; . This will cause nova to return a 401 status code for all requests not coming from my_domain.com","ref":"routing.html#secure-routing"},{"type":"extras","title":"Routing - Using plugins local to a set of endpoints","doc":"TBA","ref":"routing.html#using-plugins-local-to-a-set-of-endpoints"},{"type":"extras","title":"Routing - Configuration of error-detection in route-tree","doc":"Since Nova 0.8.0 we are using routing_tree as the underlying data structure to handle routes. routing_tree utilizes a radix-like tree structure to store the routing information and can also determine if a route already exists or creates a non-deterministic behaviour. The detection is turned off as default. This behaviour can be turned on by adding {use_strict_routing, true} under the nova key in your sys.config file. Important Be aware that the strict-mode is experimental and might cause false-positives, resulting in an exception when starting your application.","ref":"routing.html#configuration-of-error-detection-in-route-tree"},{"type":"extras","title":"Controllers","doc":"Controllers are central in how Nova works. They are in charge of handling all user-implemented logic for a request. Controllers are located in the /src/controllers/ directory of your Nova application. A controller is basically a regular Erlang module that exposes functions you've provided in the routing file.","ref":"controllers.html"},{"type":"extras","title":"Controllers - Handlers","doc":"Handlers are modules that interprets the resulting output from a controller and sends it to the requester. Handlers are identified by the first atom in the return of a controller, eg {json, \#{status =&gt; &quot;ok&quot;}} calls the json handler. You can read about the handlers below and what their functions are. JSON structures Simple interface Keyword : json Spec : {json, Structure :: map()} Example : {json, \#{status =&gt; &quot;ok&quot;}}. Converts the map (Second element in the resulting tuple) and sends it to the requester with HTTP-status code 200 . Advanced interface Keyword : json Spec : {json, StatusCode :: integer(), Headers :: map(), JSON :: map()} Example : {json, 201, \#{&quot;x-correlation-id&quot;, &quot;EX123&quot;}, \#{some_response =&gt; true}} Same as the simple interface but with two additional elements for specifying HTTP-status code and additional headers. HTML templates (Using Erlydtl) Nova renders templates using ErlyDTL ( https://github.com/erlydtl/erlydtl which uses the django template language to express logic. To get a better overview for the functionality that comes with dtl check their documentation page Simple interface Keyword : view Spec : {view, Variables :: map() | [{Key :: atom() | binary() | string(), Value :: any()}]} Example : {view, \#{my_var =&gt; &quot;123&quot;}} Renders the corresponding view with the variables attached. If a controller is named my_simple_controller.erl the view is named my_simple_view.dtl . Advanced interface Keyword : view Spec : {view, Variables :: map() | [{Key :: atom() | binary() | string(), Value :: any()}], Options :: map()} Example : {view, \#{my_var =&gt; &quot;123&quot;}, \#{view =&gt; my_view_mod}} Same as the simple interface but where you can define some options. Currently the only option for this interface is view which enables the user to specify a view other than the corresponding one based on controllers name. In the example above the dtl-file my_view_mod.dtl would be rendered. HTTP-status codes Simple interface Keyword : status Spec : {status, StatusCode :: integer()} Example : {status, 200} Returns a HTTP-code to the requester with an empty body. Medium interface Keyword : status Spec : {status, StatusCode :: integer(), ExtraHeaders :: map()} Example : {status, 200, \#{&quot;content-type&quot; =&gt; &quot;application/json&quot;}} Same as the simple interface but with an additional field for specifying additional headers. Advanced interface Keyword : status Spec : {status, Status :: integer(), ExtraHeaders :: map(), Body :: binary()} Example : {status, 200, \#{&quot;content-type&quot; =&gt; &quot;text/plain&quot;}, &quot;A plain text&quot;} Same as the medium interface but with an additional field for specifying a body. File transfers (Using cowboys sendfile functionality) Keyword : sendfile Spec : {sendfile, StatusCode :: integer(), Headers :: map(), {Offset :: integer(), Length :: integer(), Path :: list()}, Mime :: binary()} Example : {sendfile, 200, \#{}, {0, 12345, &quot;path/to/logo.png&quot;}, &quot;image/png&quot;} Sends a file using sendfile. This uses cowboys sendfile functionality and more information about it can be found in the cowboy manual on sendfile Redirecting user Keyword : redirect Spec : {redirect, Route :: list() | binary()} Example : {redirect, &quot;/my/other/path} Sends a temporary redirect (HTTP status code 302) for the specified path to requester.","ref":"controllers.html#handlers"},{"type":"extras","title":"Controllers - Fallback controllers","doc":"Phoenix have a really useful feature which they call action_fallback . We thought it would be a good addition to Nova to include something similar and therefore the fallback_controller was introduced. If a controller returns an invalid/unhandled result the fallback controller gets invoked and can take action on the payload. It's good for separating error-handling from the controllers. A fallback controller is set by setting the fallback_controller attribute with the module name of the fallback controller. The following example shows how a controller defines a fallback - module ( my_main_controller ) . - export ( [ error_example / 1 ] ) . - fallback_controller ( my_fallback_controller ) . error_example ( _Req ) -&gt; % % Since { error , ... } is not a valid handler the fallback - controller will be invoked { error , example_error } . A fallback controller exposes one function resolve/2 which returns a handler (like for regular controllers) in order to return the response to client. If we take the previous example and try and build a fallback controller for it: - module ( my_fallback_controller ) . - export ( [ resolve / 2 ] ) . resolve ( Req , { error , example_error } ) -&gt; { status , 400 } .","ref":"controllers.html#fallback-controllers"},{"type":"extras","title":"Controllers - Plugins","doc":"Plugins are part of the Nova core and can be executed both before and after the execution of a controller. They can both terminate a request early (like the request plugin does) or transform data into another structure ( json plugin ). Plugins can be defined in two different places; Global plugins are defined in the sys.config file and will be executed for every incoming request. If a plugin should only be executed for a limited set of endpoints it can be defined in the router file for that specific application (we call there local plugins ). Global plugins Global plugins are defined in the sys.config file and can have two different states: pre and post controller. They are exectued before or after a controller. Global plugins lives under the nova application, plugins key. An example of a sys.config file: { nova , [ { plugins , [ { pre_request , [ { nova_request_plugin , \#{decode_json_body =&gt; true}} ] } , { post_request , [ ] } ] } ] } . In order to find the valid options one can call the plugin_info/0 function of each plugin. Currently there are four plugins shipped with Nova. NOTE If you are creating an application that can be included in another Nova application all of your plugins should be defined in the router-file (Local plugins) in order to avoid being overwritten. Local plugins Local plugins works almost as the global ones but for a limited set of paths. Local plugins are therefore declared in the router-file for each group of endpoints. They are declared in the same way as the global ones. Example: routes ( _Env ) -&gt; [ \#{ prefix =&gt; &quot;/api/json&quot; , security =&gt; false , plugins =&gt; [ { pre_request , [ { nova_request_plugin , \#{decode_json_body =&gt; true}} ] } ] , routes =&gt; [ { &quot;/my_json_route&quot; , { my_app_json_controller , json } , \#{methods =&gt; [get, post]}} ] } ] . It's recommended to use this method of specifying routes if you plan to use it as a component in another Nova application .","ref":"controllers.html#plugins"},{"type":"extras","title":"Controllers - Websockets","doc":"Coming soon Callbacks Coming soon","ref":"controllers.html#websockets"},{"type":"extras","title":"Views","doc":"The views in Nova are powered by erlydtl . They use the Django template language and compile down to Erlang. Please read the erlydtl wiki for more information regarding the templates.","ref":"views.html"},{"type":"extras","title":"Handlers","doc":"","ref":"handlers.html"},{"type":"extras","title":"Handlers - Handlers","doc":"Handlers are a nifty thing that is called on when the controller returns. For example if the controller returns {json, \#{hello =&gt; world}} we would like Nova to create a proper JSON response to the requester. That means setting correct headers, encode the payload and send it out. This is what handlers are for. They are (often short) functions that transforms something like {json, Payload} to proper output.","ref":"handlers.html#handlers"},{"type":"extras","title":"Plugins","doc":"Plugins are a bit like the handlers except they are run on request. There's currently two different type of plugins; pre_request and post_request . These can be used to create access logs, insert CORS headers or similar. Plugins are used to handle things before and/or after a request. They are applied on all requests of a specified protocol. This is an example: - module ( correlation_id ) . - behaviour ( nova_plugin ) . - export ( [ pre_request / 2 , post_request / 2 , plugin_info / 0 ] ) . pre_request ( Req , NovaState ) -&gt; UUID = uuid :uuid_to_string ( uuid :get_v4 ( ) ) , { ok , cowboy_req :set_resp_header ( &lt;&lt; &quot;x-correlation-id&quot; &gt;&gt; , UUID , Req ) , NovaState } . post_request ( Req , NovaState ) -&gt; { ok , Req , NovaState } . plugin_info ( ) -&gt; { &lt;&lt; &quot;Correlation plugin&quot; &gt;&gt; , &lt;&lt; &quot;1.0.0&quot; &gt;&gt; , &lt;&lt; &quot;Niclas Axelsson &lt;niclas@burbas.se&gt;&quot; &gt;&gt; , &lt;&lt; &quot;Example plugin for nova&quot; &gt;&gt; } . This plugin injects a UUID into the headers. Adding a plugin Example: A good example of a very useful plugin is the nova_request_plugin . When we are developing a HTTP web api using json as the data format, we need the framework to decode our message so that we can process it. To do that we need to add decode_json_body =&gt; true into the options field in our sys.config . sys.config { nova , [ { environment , dev } , { cowboy_configuration , \#{ port =&gt; 8080 } } , { dev_mode , true } , { bootstrap_application , chatapp } , { plugins , [ { pre_request , nova_request_plugin , \#{parse_bindings =&gt; true, decode_json_body =&gt; true } } ] } ] } We have added our plugin in the plugins section. As we can see this is a pre_request plugin since it processes and decodes the message to json format before we can actually use it in our nova application endpoints. Usage: controller - module ( test_controller ) . - export ( [ increment / 1 ] ) . increment ( \#{&lt;&lt;&quot;json&quot;&gt;&gt; := \#{&lt;&lt;&quot;id&quot;&gt;&gt; := Id, &lt;&lt;&quot;value&quot;&gt;&gt; := Value}})-&gt; { json , 200 , \#{},\#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; Id , &lt;&lt;&quot;received&quot;&gt;&gt; =&gt; Value, &lt;&lt;&quot;increment&quot;&gt;&gt; =&gt; Value+1}}.","ref":"plugins.html"},{"type":"extras","title":"Plugins - Nova plugins","doc":"Nova has a couple of plugins for some general purposes. Plugin Description Code nova_correlation_plugin This plugin will add a correlation id to header response but also add \#{correlation_id =&gt; CorrelationID} to the request obj that is passed to the controller. nova_correlation_plugin nova_cors_plugin This plugin will handle cors and add the cors headers into the request. nova_cors_plugin nova_request_plugin This plugin will handle incomming data like qs, form urlencoded and json nova_request_plugin Nova correlation This plugin will generate a uuid v4 and set it as a response header as X-Correlation-ID if nothing is configuered. { pre_request ; nova_correlation_plugin , \#{ request_correlation_header =&gt; CorrelationHeader , logger_metadata_key =&gt; LoggerMetaDataKey } } Option Description request_correlation_header This is if you want a different correlation header than the standard X-Correlation-ID logger_metadata_key This is if you want to have a different metadata key then the standard correaltion_id Nova cors This plugins will make it so that if we get method OPTIONS it will just return back the CORS headers. In this case you don't need a controller to handle it and the plugin stops after this. For other methods it will add the CORS headers to the request. { pre_request ; nova_cors_plugin , \#{ allow_origins =&gt; &lt;&lt; &quot;*&quot; &gt;&gt; } } Option Description allow_origins Specifies which origins to insert into Access-Control-Allow-Origin Nova request This plugins handle incoming data and can transform them to erlang maps depending on what the options are. { pre_request ; nova_correlation_plugin , \#{ decode_json_body =&gt; true , read_urlencoded_body =&gt; true , parse_qs =&gt; true | list } } Option Description Req decode_json_body If header is application/json it will decode the body. Req\#{json =&gt; Map} read_urlencoded_body If header is application/x-www-form-urlencoded it will decode it. Req\#{params =&gt; Map} parse_qs If the path have qs in it we will get them. Req\#{parsed_qs =&gt; Map or List}","ref":"plugins.html#nova-plugins"},{"type":"extras","title":"Building releases","doc":"Nova utilizes relx for building releases and has a particular profile defined for creating such. $ rebar3 as prod tar This builds a release and archives it into a tar-file. As default erts is included in the release, but this can be configured through the options in rebar.config . To read more about release handling and configuration options we recommend reading relx-manual.","ref":"building-releases.html"},{"type":"extras","title":"Books and links","doc":"","ref":"books-and-links.html"},{"type":"extras","title":"Books and links - Online books","doc":"Learn you some Erlang","ref":"books-and-links.html#online-books"},{"type":"extras","title":"Books and links - Books","doc":"Learn you some Erlang Erlang OTP in action","ref":"books-and-links.html#books"},{"type":"extras","title":"Books and links - Blogs &amp; Articles","doc":"","ref":"books-and-links.html#blogs-articles"},{"type":"extras","title":"Rebar3 Nova","doc":"With Nova we have a rebar3 plugin that comes with some commands:","ref":"rebar3_nova.html"},{"type":"extras","title":"Rebar3 Nova - Development mode","doc":"When running rebar3 nova serve it will start a node (same as rebar3 shell) but it will reload/recompile erlang modules and dtl files. This helps when developing new solutions and it is something that needs to be solved.","ref":"rebar3_nova.html#development-mode"},{"type":"extras","title":"Nova Pubsub","doc":"With version 0.9.4 we introduced the concept of a pubsub-like mechanism in Nova so that users can build distributed services. Internally it relies on Erlangs pg2 -module which enables distributed named process groups. The concept is really simple and there's not much depth in the current implementation - it should only be used as a simple message bus. If you need more advanced features please take a look at RabbitMQ or MQTT .","ref":"nova-pubsub.html"},{"type":"extras","title":"Nova Pubsub - Basic concepts","doc":"The idea is that a process subscribes to a topic . If there's any messages sent to this topic all the subscribed processes receivs that message. This picture shows how two processes have subscribed to a topic (Or channel) &quot;Messages&quot;. When another process then sends &quot;Hello&quot;* on this topic the other two will receive it.","ref":"nova-pubsub.html#basic-concepts"},{"type":"extras","title":"Nova Pubsub - Example","doc":"- module ( test_module ) . - export ( [ player1 / 0 , player2 / 0 , start_game / 0 ] ) . player1 ( ) -&gt; spawn ( fun ( ) -&gt; nova_pubsub : join ( game_of_pong ) , game_loop ( 1 , &quot;pong&quot; , &quot;ping&quot; ) end ) . player2 ( ) -&gt; spawn ( fun ( ) -&gt; nova_pubsub : join ( game_of_pong ) , game_loop ( 2 , &quot;ping&quot; , &quot;pong&quot; ) end ) . game_loop ( Player , ExpectedMessage , Smash ) -&gt; receive ExpectedMessage -&gt; io : format ( &quot;Player ~d received ~s and returning ~s ~n &quot; , [ Player , ExpectedMessage , Smash ] ) , nova_pubsub : broadcast ( game_of_pong , &quot;match1&quot; , Smash ) , game_loop ( Player , ExpectedMessage , Smash ) ; _ -&gt; game_loop ( Player , ExpectedMessage , Smash ) end . Here we are subscribing to a topic &quot;game_of_pong&quot; which we later use to send either ping or pong to, depending on which player that are serving. This can ofcourse be extended to do so much more, but this is a taste of what one can use nova_pubsub to.","ref":"nova-pubsub.html#example"},{"type":"extras","title":"Nova Pubsub - Configuration","doc":"It does not require any specific parameters set in order to work. Just remember to enable distributed erlang .","ref":"nova-pubsub.html#configuration"}]